#ifndef MARS_MHEvent
#define MARS_MHEvent

#ifndef MARS_MH
#include "MH.h"
#endif

class MHCamera;
class MRawEvtData;
class MRawRunHeader;
class MRawEvtHeader;

class MTime;
class MMcEvt;
class MMcTrig;
class MSignalCam;
class MImgCleanStd;

class MHEvent : public MH
{
public:
    enum EventType_t {
        kEvtSignalRaw, kEvtSignalDensity,
        kEvtPedestal, kEvtPedestalRMS,
        kEvtPedPhot, kEvtPedPhotRMS,
        kEvtCleaningLevels, kEvtCleaningData,
        kEvtIdxMax, kEvtArrTime, kEvtTrigPix, kEvtIslandIndex
    };

private:
    MRawEvtData   *fRawEvtData;    //!
    MRawRunHeader *fRawRunHeader;  //!
    MRawEvtHeader *fRawEvtHeader;  //!

    MTime         *fTime;          //!
    MMcEvt        *fMcEvt;         //!
    MMcTrig       *fMcTrig;        //!
    MSignalCam    *fCerPhotEvt;    //!
    MImgCleanStd  *fImgCleanStd;   //!

    MRawEvtData   *fClone;         //->

    MHCamera *fHist;

    EventType_t fType;

    TH1 *GetHistByName(const TString name) const { return (TH1*)fHist; }

    Bool_t SetupFill(const MParList *plist);
    Bool_t Fill(const MParContainer *par, const Stat_t weight=1);

public:
    MHEvent(EventType_t type=kEvtSignalRaw);
    ~MHEvent();

    MHCamera *GetHist() { return fHist; }

    void Draw(Option_t *o="");
    void Paint(Option_t *o="");
 
    ClassDef(MHEvent, 1)
};

#endif
